﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Collections.BinaryTree;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using System.Collections;

namespace DataGrid
{
    public partial class Form1 : Form
    {
        #region "API Definition"
        private int rowcount = 70;
        private string[] dept = { "CIVIL", "MECHANICAL", "EEE", "ECE", "IT", "CSE", "BIO-TECH", "AERO", "MARINE", "TEXTILE" };
        private DataTable dt;
        #endregion

        #region "Constructor"
        public Form1()
        {
            InitializeComponent();

            #region DataSource
            dt = new DataTable();
            dt.Columns.Add("Department",typeof(string));
            dt.Columns.Add("Code",typeof(int));
            dt.Columns.Add("Fees", typeof(int));
            dt.Columns.Add("Invoice", typeof(string));

            Random r = new Random(124321);
            for (int i = 0; i < rowcount; i++)
            {
                DataRow dr = dt.NewRow();
                dr[0] = dept[r.Next(0, 9)];
                dr[1] = r.Next(100, 200);
                dr[2] = r.Next(12000,20000);
                dr[3] = r.Next(1, 10000);
                dt.Rows.Add(dr);
            }
            #endregion

            this.gridGroupingControl1.DataSource = dt;
            this.gridGroupingControl1.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            for (int i = 0; i < this.gridGroupingControl1.TableDescriptor.Columns.Count; i++ )
            {
                this.gridGroupingControl1.TableDescriptor.Columns[i].AllowFilter = true;
                this.gridGroupingControl1.TableDescriptor.Columns[i].Width = 100;
            }

            GridTableFilterBarExtCellModel filterBarExtCell = new GridTableFilterBarExtCellModel(this.gridGroupingControl1.TableModel);
            this.gridGroupingControl1.TableModel.CellModels.Add("DynamicFilter", filterBarExtCell);
            this.gridGroupingControl1.TableDescriptor.Appearance.FilterBarCell.CellType = "DynamicFilter";
             
            #region Grid events
            this.gridGroupingControl1.TableControlCurrentCellKeyDown += new GridTableControlKeyEventHandler(gridGroupingControl1_TableControlCurrentCellKeyDown);
            this.checkBox1.CheckStateChanged += new EventHandler(checkBox1_CheckStateChanged);
            #endregion
        }

        #endregion

        #region "Events"
        //Handle the Alt + Down Arrow key functionalities
        void gridGroupingControl1_TableControlCurrentCellKeyDown(object sender, GridTableControlKeyEventArgs e)
        {
            GridCurrentCell cc = e.TableControl.CurrentCell;
            GridTableCellStyleInfo style = e.TableControl.GetTableViewStyleInfo(cc.RowIndex, cc.ColIndex);
            if (e.Inner.Alt && e.Inner.KeyCode == Keys.Down)
            {
                if (style.CellType == "DynamicFilter")
                e.Inner.Handled = true;
            }
            else
            {
                e.Inner.Handled = false;
            }
        }

        //Enable or disable the filter option
        void checkBox1_CheckStateChanged(object sender, EventArgs e)
        {
            if (this.checkBox1.CheckState == CheckState.Checked)
            {
                this.gridGroupingControl1.TopLevelGroupOptions.ShowFilterBar = true;
            }
            else if (this.checkBox1.CheckState == CheckState.Unchecked)
            {
                this.gridGroupingControl1.TopLevelGroupOptions.ShowFilterBar = false;
            }
        }

        #endregion
    }
}
